
// compile: g++ -o functions.ex functions.cpp

#include <iostream>

using namespace std;

#define PI 3.1415926


// cylinder
double volume(double height, double radius=1.0) {
  return PI*radius*radius*height;
  }

// hollow cylinder
  double volume(double height, double r1, double r2) {
  return PI*(r1*r1-r2*r2)*height;
  }

  
/*
//hollow cylinder (this produces a compiler error)
double volume(double height, double r1, double r2=0.0) {
  return PI*(r1*r1-r2*r2)*height;
  }
*/


int main()
  {
    
  cout << "volume(1.0)=" << volume(1.0) << ", volume(2.0,1.0)=" << volume(2.0,2.0) << endl;
  cout << "volume(1.0,1.0,0.9)=" << volume(1.0,1.0,0.9) << endl;
    
  return 0;
  }
  

