// compile: g++ -o pointer.ex pointer.cpp

#include <iostream>

using namespace std;

int main()
  {
  // example 1
  int value;
  int *p;
  p=&value;
  *p=10;
  cout << value << endl;
  
  // example 2
  int value1=7, value2=5;
  int *p1, *p2;
  p1=&value1;
  p2=&value2;
  *p1=10;
  *p2=*p1;
  p1=p2;
  *p1=20;
  cout << value1 << " " << value2 << endl;
  
  // example 3
  int numbers[5];
  int *p3;
  p3=numbers; *p3=10;
  p3++; *p3=20;
  p3=&numbers[2]; *p3=30;
  p3=numbers+3; *p3=40;
  p3=numbers; *(p3+4)=50;
  for(int n=0;n<5;n++) cout << numbers[n] << " ";
  cout << endl;
  
  // example 4
  char a;
  char *b;
  char **c;
  a='z';
  b=&a;
  c=&b;
  cout << **c << endl;
    
  return 0;
  }