// compile: g++ -o inheritance.ex inheritance.cpp

#include <iostream> 
using namespace std;

class polygon {
  
  protected:
    double width, height;
    
  public:
    void set(double a, double b) { width=a; height=b; }
    
  };
  
  
class rectangle : public polygon {
  
  public:
    double area () { return (width*height); }
    
  };
  
  
class triangle : public polygon {
  
  public:
    double area () { return (width*height/2); }
    
  };


int main()
  {

  rectangle r;
  triangle t;
  
  r.set(4.0,5.0);
  t.set(4.0,5.0);
  
  cout << r.area() << endl; // --> 20.0
  cout << t.area() << endl; // --> 10.0    
    
  return 0;
  }

